var Util = {};
Array.prototype.push8 = function(a) {
    this.push(a & 255)
};
Array.prototype.push16 = function(a) {
    this.push(a >> 8 & 255, a & 255)
};
Array.prototype.push32 = function(a) {
    this.push(a >> 24 & 255, a >> 16 & 255, a >> 8 & 255, a & 255)
};
Array.prototype.map || (Array.prototype.map = function(a, e) {
    var d = this.length;
    if ("function" != typeof a) throw new TypeError;
    for (var b = Array(d), c = 0; c < d; c++) c in this && (b[c] = a.call(e, this[c], c, this));
    return b
});
Array.prototype.indexOf || (Array.prototype.indexOf = function(a, e) {
    var d = this.length >>> 0,
        b = Number(e) || 0,
        b = 0 > b ? Math.ceil(b) : Math.floor(b);
    for (0 > b && (b += d); b < d; b++)
        if (b in this && this[b] === a) return b;
    return -1
});
window.requestAnimFrame = function() {
    return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(a) {
        window.setTimeout(a, 1E3 / 60)
    }
}();
Util._log_level = "none";
Util.init_logging = function(a) {
    "undefined" === typeof a ? a = Util._log_level : Util._log_level = a;
    "undefined" === typeof window.console && (window.console = "undefined" !== typeof window.opera ? {
        log: window.opera.postError,
        warn: window.opera.postError,
        error: window.opera.postError
    } : {
        log: function(a) {},
        warn: function(a) {},
        error: function(a) {}
    });
    Util.Debug = Util.Info = Util.Warn = Util.Error = function(a) {};
    switch (a) {
        case "debug":
            Util.Debug = function(a) {
                console.log(a)
            };
        case "info":
            Util.Info = function(a) {
                console.log(a)
            };
        case "warn":
            Util.Warn =
                function(a) {
                    console.warn(a)
                };
        case "error":
            Util.Error = function(a) {
                console.error(a)
            };
        case "none":
            break;
        default:
            throw "invalid logging type '" + a + "'";
    }
};
Util.get_logging = function() {
    return Util._log_level
};
Util.init_logging();
Util.conf_default = function(a, e, d, b, c, f, g, l) {
    var k, h;
    k = function(c) {
        return f in {
            arr: 1,
            array: 1
        } && "undefined" !== typeof c ? a[b][c] : a[b]
    };
    h = function(c, d) {
        f in {
            "boolean": 1,
            bool: 1
        } ? c = !c || c in {
            0: 1,
            no: 1,
            "false": 1
        } ? !1 : !0 : f in {
            integer: 1,
            "int": 1
        } ? c = parseInt(c, 10) : "str" === f ? c = String(c) : "func" === f && (c || (c = function() {}));
        "undefined" !== typeof d ? a[b][d] = c : a[b] = c
    };
    e[b + "_description"] = l;
    "undefined" === typeof e["get_" + b] && (e["get_" + b] = k);
    "undefined" === typeof e["set_" + b] && (e["set_" + b] = function(d, e) {
        if (c in {
                RO: 1,
                ro: 1
            }) throw b +
            " is read-only";
        if (c in {
                WO: 1,
                wo: 1
            } && "undefined" !== typeof a[b]) throw b + " can only be set once";
        h(d, e)
    });
    "undefined" !== typeof d[b] ? g = d[b] : f in {
        arr: 1,
        array: 1
    } && !(g instanceof Array) && (g = []);
    h(g)
};
Util.conf_defaults = function(a, e, d, b) {
    var c;
    for (c = 0; c < b.length; c++) Util.conf_default(a, e, d, b[c][0], b[c][1], b[c][2], b[c][3], b[c][4])
};
Util.decodeUTF8 = function(a) {
    return decodeURIComponent(escape(a))
};
Util.get_include_uri = function() {
    return "undefined" !== typeof INCLUDE_URI ? INCLUDE_URI : "modules/servers/ovh_api/ovh/kvm/include/"
};
Util._loading_scripts = [];
Util._pending_scripts = [];
Util.load_scripts = function(a) {
    for (var e = document.getElementsByTagName("head")[0], d, b = Util._loading_scripts, c = Util._pending_scripts, f = 0; f < a.length; f++) d = document.createElement("script"), d.type = "text/javascript", d.src = Util.get_include_uri() + a[f], d.onload = d.onreadystatechange = function(a) {
        for (; 0 < b.length && ("loaded" === b[0].readyState || "complete" === b[0].readyState);) a = b.shift(), e.appendChild(a);
        if ((!this.readyState || Util.Engine.presto && "loaded" === this.readyState || "complete" === this.readyState) && 0 <= c.indexOf(this) &&
            (this.onload = this.onreadystatechange = null, c.splice(c.indexOf(this), 1), 0 === c.length && window.onscriptsload)) window.onscriptsload()
    }, Util.Engine.trident ? b.push(d) : (d.async = !1, e.appendChild(d)), c.push(d)
};
Util.getPosition = function() {
    return function(a) {
        for (var e = 0, d = 0, b = a, c = !1;
            (b = b.parentNode) && b != document.body;) {
            e -= b.scrollLeft || 0;
            d -= b.scrollTop || 0;
            if (b.currentStyle) var f = b.currentStyle.position;
            else window.getComputedStyle && (f = window.getComputedStyle(b, null).position);
            "fixed" == f && (c = !0)
        }
        c && !window.opera && (c = b = 0, c = document.getElementsByTagName("html")[0], b = c.scrollTop && document.documentElement.scrollTop ? c.scrollTop : c.scrollTop || document.documentElement.scrollTop ? c.scrollTop + document.documentElement.scrollTop :
            document.body.scrollTop ? document.body.scrollTop : 0, c = c.scrollLeft && document.documentElement.scrollLeft ? c.scrollLeft : c.scrollLeft || document.documentElement.scrollLeft ? c.scrollLeft + document.documentElement.scrollLeft : document.body.scrollLeft ? document.body.scrollLeft : 0, b = [c, b], e += b[0], d += b[1]);
        do e += a.offsetLeft, d += a.offsetTop; while (a = a.offsetParent);
        return {
            x: e,
            y: d
        }
    }
}();
Util.getEventPosition = function(a, e, d) {
    var b, c;
    a = a ? a : window.event;
    a = a.changedTouches ? a.changedTouches[0] : a.touches ? a.touches[0] : a;
    if (a.pageX || a.pageY) b = a.pageX, c = a.pageY;
    else if (a.clientX || a.clientY) b = a.clientX + document.body.scrollLeft + document.documentElement.scrollLeft, c = a.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    a = Util.getPosition(e);
    "undefined" === typeof d && (d = 1);
    b -= a.x;
    c -= a.y;
    a = Math.max(Math.min(b, e.width - 1), 0);
    e = Math.max(Math.min(c, e.height - 1), 0);
    return {
        x: a / d,
        y: e / d,
        realx: b /
            d,
        realy: c / d
    }
};
Util.addEvent = function(a, e, d) {
    if (a.attachEvent) return a.attachEvent("on" + e, d);
    if (a.addEventListener) return a.addEventListener(e, d, !1), !0;
    throw "Handler could not be attached";
};
Util.removeEvent = function(a, e, d) {
    if (a.detachEvent) return a.detachEvent("on" + e, d);
    if (a.removeEventListener) return a.removeEventListener(e, d, !1), !0;
    throw "Handler could not be removed";
};
Util.stopEvent = function(a) {
    a.stopPropagation ? a.stopPropagation() : a.cancelBubble = !0;
    a.preventDefault ? a.preventDefault() : a.returnValue = !1
};
Util.Features = {
    xpath: !!document.evaluate,
    air: !!window.runtime,
    query: !!document.querySelector
};
Util.Engine = {
    presto: function() {
        return window.opera ? !0 : !1
    }(),
    trident: function() {
        return window.ActiveXObject ? window.XMLHttpRequest ? document.querySelectorAll ? 6 : 5 : 4 : !1
    }(),
    webkit: function() {
        try {
            return navigator.taintEnabled ? !1 : Util.Features.xpath ? Util.Features.query ? 525 : 420 : 419
        } catch (a) {
            return !1
        }
    }(),
    gecko: function() {
        return document.getBoxObjectFor || null != window.mozInnerScreenX ? document.getElementsByClassName ? 19 : 18 : !1
    }()
};
Util.Engine.webkit && (Util.Engine.webkit = function(a) {
    a = (navigator.userAgent.match(/WebKit\/([0-9.]*) /) || ["", a])[1];
    return parseFloat(a, 10)
}(Util.Engine.webkit));
Util.Flash = function() {
    var a;
    try {
        a = navigator.plugins["Shockwave Flash"].description
    } catch (e) {
        try {
            a = (new ActiveXObject("ShockwaveFlash.ShockwaveFlash")).GetVariable("$version")
        } catch (d) {
            a = "0 r0"
        }
    }
    a = a.match(/\d+/g);
    return {
        version: parseInt(a[0] || "0." + a[1], 10) || 0,
        build: parseInt(a[2], 10) || 0
    }
}();