<!-- Required for MRTG -->
<script src="./modules/servers/ovh_api/resources/js/highcharts.js"></script>
{if $updated}
	<div class="alert alert-success" role="alert"> <strong>Updated!</strong> You successfully modified settings. </div>
{/if}
{if $error}
	<div class="alert alert-danger" role="alert"> <strong>Uh-oh!</strong> Something went wrong.<br>{$error} </div>
{/if}
{if $notice}
	<div class="alert alert-warning" role="alert"> <strong>Hold up!</strong> {$notice} </div>
{/if}
{if isset($alert)}
	<div class="alert alert-{$alert.type} alert-dismissible fade in" role="alert">
	      <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span></button>
	      <strong>{$alert.title}</strong>
	      <p>{$alert.message}</p>
	</div>
{/if}

	<style>
	.bsHeader {
		background: #337AB7;
		color: #FFF;
		text-align: right;
		border: 0 !important;
		font-weight: normal;
	}
	.bsTable {
    border-collapse: collapse;
    border-radius: 3px;
    border-style: hidden;
    box-shadow: 0 0 0 1px #337AB7;
	}
	</style>

	<table class="table table-bordered bsTable">
	  <tbody>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_OperatingSystem}</th>
	          <td>{$client.general->os} <br/><small>{$client.bootDevice->description}</small></td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_IPAddress}</th>
	          <td>{$client.general->ip}</td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_Reverse}</th>
	          <td>{$client.general->reverse}</td>
	      </tr>
				
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_Memory}</th>
	          <td>{$client.serviceInfos->memorySize->value} {$client.serviceInfos->memorySize->unit}</td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_ProcessorArchitecture}</th>
	          <td>{$client.serviceInfos->processorArchitecture}</td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_ProcessorName}</th>
	          <td>{$client.serviceInfos->processorName}</td>
	      </tr>
				
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_Connection}</th>
	          <td>{$client.network->connection->value} {$client.network->connection->unit}</td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_Server2Internet}</th>
	          <td>{$client.network->bandwidth->OvhToInternet->value} {$client.network->bandwidth->OvhToInternet->unit}</td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_Server2Server}</th>
	          <td>{$client.network->bandwidth->OvhToOvh->value} {$client.network->bandwidth->OvhToOvh->unit}</td>
	      </tr>
	      <tr>
	        <th class="bsHeader">{$translate.PANEL_Internet2Server}</th>
	          <td>{$client.network->bandwidth->InternetToOvh->value} {$client.network->bandwidth->InternetToOvh->unit}</td>
	      </tr>

	      <tr>
	        <th class="bsHeader">{$translate.PANEL_SrvMonitoring}</th>
	          <td>{$client.status}</td>	      	
	      </tr>

		{if $client.spam.state eq 'spam'}
	      <tr style="list-style: none;">
	        <th class="bsHeader">Spam detected</th>
	          <td>
	          	
							{foreach from=$client.spam.ips item=spam}
								{foreach from=$spam.ips item=ip}
							    <li>
										<form method="post" action="clientarea.php?action=productdetails">
										<input type="hidden" name="id" value="{$serviceid}" />
										<input type="hidden" name="ip" value="{$ip}" />
										<input type="hidden" name="ipBlock" value="{$spam.ipBlock}" />
			  						<input type="hidden" name="modop" value="custom" />
			  						<input type="hidden" name="run_action" value="unblockSpam" />
										<input type="submit" class="btn btn-default pull-right" value="Unblock {$ip}" />
										</form>
									</li>
								{/foreach}
							{/foreach}
							
	          </td>
	      </tr>
		{/if}
				
	  </tbody>
	</table>

<div class="row">
	<div class="col-sm-6">
		<div class="form-group">
			<select id="mon_type" class="form-control" onchange="chart()">
			  <option value="daily">Last 24 hours</option>
			  <option value="hourly">Last hour</option>
			  <option value="monthly" selected>Last 30 days</option>
				<option value="weekly">Last 7 days</option>
				<option value="yearly">Last 12 months</option>
			</select>
		</div>
	</div>
	
	<div class="col-sm-6">
		<div class="form-group">
			<select id="mon_period" class="form-control" onchange="chart()">
			  <option value="traffic" selected>Traffic</option>
			  <option value="packets">Packets</option>
			</select>
		</div>
	</div>
</div>

<div id="monitoring_container"></div>
<div id="mrtgRam" style="min-width: 310px; height: 250px; width:550px; margin: 0 auto"></div>


{literal}
	<script type="text/javascript">
$(function () {
  
				var rChart;
				
        $('#mrtgRam').highcharts({
				chart: {
					type: 'spline'
				},
				title: {
					text: '{/literal}{$translate.PANEL_Monitoring}{literal}'
				},
				credits: {
				      enabled: false
				},
				subtitle: {
					text: ''
				},
				turboThreshold: 0,
				xAxis: {
					type: 'datetime',
					dateTimeLabelFormats: {
						month: '%e. %b',
						year: '%b'
					},
					title: {
						text: 'Date'
					}
				},
				yAxis: {
					title: {
						text: ''
					},
					min: 0
				},
				tooltip: {
					headerFormat: '<b>{series.name}</b><br>',
					pointFormat: '{point.x:%e. %b}: {point.y:.2f} m'
				},
				series: {/literal}{$charts}{literal}
				});
        
				rChart = $('#mrtgRam').highcharts();		
        
				var HttpClient = function() {
				    this.get = function(aUrl, aCallback) {
				        var anHttpRequest = new XMLHttpRequest();
				        anHttpRequest.onreadystatechange = function() { 
				            if (anHttpRequest.readyState == 4 && anHttpRequest.status == 200)
				                aCallback(anHttpRequest.responseText);
				        }
				        anHttpRequest.open( "GET", aUrl, true );            
				        anHttpRequest.send( null );
				    }
				}
   
				chart = function() {
						aClient = new HttpClient();
						
						aClient.get(encodeURI(window.location.href +"&getChart="+document.getElementById("mon_type").value+"&period="+document.getElementById("mon_period").value), function(response) {
								var data = JSON.parse(response);
								while(rChart.series.length > 0)
								{
								    rChart.series[0].remove(true);
								}

							  rChart.addSeries(data[0], false);
							  rChart.addSeries(data[1]);


								
						});
				}
        
	});//end script
	</script>
{/literal}